package org.ts.ddcs.DataItemTemplate;

import org.ts.ddcs.Log.LogHelper;
import org.ts.ddcs.Tool.BytesHelp;
import org.ts.ddcs.Tool.StringUtil;

import java.math.BigDecimal;

/**
 * 15
 * 60厘米处土壤含水量
 */
@SuppressWarnings("all")
public class DataItemTemplateM60 extends DataItemTemplate {
    @Override
    public byte[] Stream(byte[] data) {
        byte[] remain = data;
        if (this.macth) {
            return remain;
        }
        int count = 0;
        String flag = BytesHelp.byte2HexStr(remain, count, 1);
        count += 1;
        if (flag.equals(this.feture)) {
            byte[] len = BytesHelp.subBytes(remain, count, 1);
            count += 1;
            int dataTotalLen = len[0] >> 3;
            int decimalLen = len[0] & 7;
            byte[] buff = BytesHelp.subBytes(remain, count, dataTotalLen);
            String hexStr = BytesHelp.byte2HexStr(buff);
            StringBuffer dataStr = new StringBuffer(hexStr);
            if (decimalLen != 0) {
                dataStr.insert(dataStr.length() - decimalLen, ".");
            }
            count += dataTotalLen;
            String value = StringUtil.getPrettyNumber(dataStr.toString());
            this.bigDecimalValue = new BigDecimal(value);
            remain = BytesHelp.subBytes(remain, count, remain.length - count);
            this.macth = true;
        }
        return remain;
    }
}
